package net.pricefx.formulaengine.scripting;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

import com.googlecode.genericdao.search.Filter;

import net.pricefx.common.apibuilder.chart.ChartBuilder;
import net.pricefx.domain.Customer;
import net.pricefx.domain.CustomerGroup;
import net.pricefx.domain.Product;
import net.pricefx.domain.ProductGroup;
import net.pricefx.formulaengine.ModelRecordSummaryQuery;

/**
 * This interface is internally (and actually) used as the groovy api binding.
 * Methods that should NOT be used "externally" by formula writers should go in here.
 */
public interface ISandboxAPI extends PublicGroovyAPI {

	Map<String,Object> global = new HashMap();
	Map<String,Object> local = new HashMap();

	/**
	 * INTERNAL ONLY
	 * Sends metrics to graphite
	 * 
	 * @param metrics The metrics to send
	 * 
	 */
	public void sendMetrics(Map<String, Integer> metrics);

	Product getProduct(String sku);

	Customer getCustomer(String customerId);

	Customer getCustomerParent(String customerId);


	Object findRebateRecords(String rebateTypeUN, Date startDate, Date endDate,
	                                CustomerGroup customerGroup, ProductGroup productGroup, Filter... filters);

	Object getClusterNodes();

	ChartBuilder newChartBuilder();
	
 	Object importDataLoad(Map<String,Object> dataLoadAsJsonMap); 

 	Object getOptimizer();

	Object modelEvaluator(String configuratorName, String modelName);

	ModelRecordSummaryQuery getModelRecordSummaryQuery();

	Object modelRecords(String modelUniqueNameOrLabel, Map<String,Object> filterCriteria);

}