package net.pricefx.logic.core.model;

import java.util.List;
import java.util.Map;

import static net.pricefx.common.api.PriceFxInterface.*;

public abstract class AbstractFormulaElement extends ObjectHolder {

	public AbstractFormulaElement() {
		super();
	}

	public AbstractFormulaElement(Map element) {
		super(element);
	}

	public abstract AbstractFormulaElement copy();

	public String getElementName() {
		return getTextValue(FIELD_FE_ELEMENTNAME);
	}

	public void setElementName(String elementName) {
		setTextValue(FIELD_FE_ELEMENTNAME, elementName);
	}

	public String getElementLabel() {
		return getTextValue(FIELD_FE_ELEMENTLABEL);
	}

	public void setElementLabel(String elementLabel) {
		setTextValue(FIELD_FE_ELEMENTLABEL, elementLabel);
	}

	public String getFormulaExpression() {
		return getTextValue(FIELD_FE_FORMULAEXPRESSION);
	}

	public void setFormulaExpression(String formulaExpression) {
		setTextValue(FIELD_FE_FORMULAEXPRESSION, formulaExpression);
	}

	public String getElementDescription() {
		return getTextValue(FIELD_FE_ELEMENTDESC);
	}

	public void setElementDescription(String elementDescription) {
		setTextValue(FIELD_FE_ELEMENTDESC, elementDescription);
	}

	public Boolean getHideWarnings() {
		return Boolean.TRUE.equals(getBooleanValue(FIELD_FE_HIDEWARNINGS));
	}

	public void setHideWarnings(Boolean hideWarnings) {
		setBooleanValue(FIELD_FE_HIDEWARNINGS, hideWarnings);
	}

	public List<String> getElementGroups() {
		return getArrayValue(FIELD_FE_ELEMENTGROUPS);
	}

	public void setElementGroups(List<String> elementGroups) {
		setArrayValue(FIELD_FE_ELEMENTGROUPS, elementGroups);
	}

	public String getConditionElementName() {
		return getTextValue(FIELD_FE_ELEMENTCONDITION);
	}

	public void setConditionElementName(String conditionElementName) {
		setTextValue(FIELD_FE_ELEMENTCONDITION, conditionElementName);
	}

	public String getCombinationType() {
		return getTextValue(FIELD_FE_COMBINATIONTYPE);
	}

	public void setCombinationType(String combinationType) {
		setTextValue(FIELD_FE_COMBINATIONTYPE, combinationType);
	}

	public Long getElementTimeout() {
		return getLongValue(FIELD_FE_ELEMENTTIMEOUT);
	}

	public void setElementTimeout(Long elementTimeout) {
		setLongValue(FIELD_FE_ELEMENTTIMEOUT, elementTimeout);
	}

/*	String getTypedId();
	void setTypedId(String typedId);

	String getCreateDate();
	void setCreateDate(String createDate);

	Long getCreatedBy();
	void setCreatedBy(Long createdBy);

	String getLastUpdateDate();
	void setLastUpdateDate(String lastUpdateDate);

	Long getLastUpdateBy();
	void setLastUpdateBy(Long lastUpdateBy);

	Long getVersion();
	void setVersion(Long version);*/

	public boolean equals(AbstractFormulaElement obj) {
		return obj != null &&
				(holder == null ? obj.holder == null : holder.equals(obj.holder));
	}
}
